// sine table with 256 steps
module sineTable18bit (CLK, sine_addr, sine_out);
   input CLK;
   wire  CLK;
   input [7:0] sine_addr;
   wire [7:0]  sine_addr;
   output [17:0] sine_out;
   reg [17:0]    sine_out;

   always @(posedge CLK) begin
      case(sin_addr)
        8'h00: sine_out = 18'h00000; // sine_out = 0.000000
        8'h01: sine_out = 18'h00648; // sine_out = 0.024541
        8'h02: sine_out = 18'h00c8f; // sine_out = 0.049068
        8'h03: sine_out = 18'h012d5; // sine_out = 0.073565
        8'h04: sine_out = 18'h01917; // sine_out = 0.098017
        8'h05: sine_out = 18'h01f56; // sine_out = 0.122411
        8'h06: sine_out = 18'h02590; // sine_out = 0.146730
        8'h07: sine_out = 18'h02bc4; // sine_out = 0.170962
        8'h08: sine_out = 18'h031f1; // sine_out = 0.195090
        8'h09: sine_out = 18'h03817; // sine_out = 0.219101
        8'h0a: sine_out = 18'h03e33; // sine_out = 0.242980
        8'h0b: sine_out = 18'h04447; // sine_out = 0.266713
        8'h0c: sine_out = 18'h04a50; // sine_out = 0.290285
        8'h0d: sine_out = 18'h0504d; // sine_out = 0.313682
        8'h0e: sine_out = 18'h0563e; // sine_out = 0.336890
        8'h0f: sine_out = 18'h05c22; // sine_out = 0.359895
        8'h10: sine_out = 18'h061f7; // sine_out = 0.382683
        8'h11: sine_out = 18'h067bd; // sine_out = 0.405241
        8'h12: sine_out = 18'h06d74; // sine_out = 0.427555
        8'h13: sine_out = 18'h07319; // sine_out = 0.449611
        8'h14: sine_out = 18'h078ad; // sine_out = 0.471397
        8'h15: sine_out = 18'h07e2e; // sine_out = 0.492898
        8'h16: sine_out = 18'h0839c; // sine_out = 0.514103
        8'h17: sine_out = 18'h088f5; // sine_out = 0.534998
        8'h18: sine_out = 18'h08e39; // sine_out = 0.555570
        8'h19: sine_out = 18'h09368; // sine_out = 0.575808
        8'h1a: sine_out = 18'h0987f; // sine_out = 0.595699
        8'h1b: sine_out = 18'h09d7f; // sine_out = 0.615232
        8'h1c: sine_out = 18'h0a267; // sine_out = 0.634393
        8'h1d: sine_out = 18'h0a736; // sine_out = 0.653173
        8'h1e: sine_out = 18'h0abeb; // sine_out = 0.671559
        8'h1f: sine_out = 18'h0b085; // sine_out = 0.689541
        8'h20: sine_out = 18'h0b504; // sine_out = 0.707107
        8'h21: sine_out = 18'h0b968; // sine_out = 0.724247
        8'h22: sine_out = 18'h0bdae; // sine_out = 0.740951
        8'h23: sine_out = 18'h0c1d8; // sine_out = 0.757209
        8'h24: sine_out = 18'h0c5e4; // sine_out = 0.773010
        8'h25: sine_out = 18'h0c9d1; // sine_out = 0.788346
        8'h26: sine_out = 18'h0cd9f; // sine_out = 0.803208
        8'h27: sine_out = 18'h0d14d; // sine_out = 0.817585
        8'h28: sine_out = 18'h0d4db; // sine_out = 0.831470
        8'h29: sine_out = 18'h0d848; // sine_out = 0.844854
        8'h2a: sine_out = 18'h0db94; // sine_out = 0.857729
        8'h2b: sine_out = 18'h0debe; // sine_out = 0.870087
        8'h2c: sine_out = 18'h0e1c5; // sine_out = 0.881921
        8'h2d: sine_out = 18'h0e4aa; // sine_out = 0.893224
        8'h2e: sine_out = 18'h0e76b; // sine_out = 0.903989
        8'h2f: sine_out = 18'h0ea09; // sine_out = 0.914210
        8'h30: sine_out = 18'h0ec83; // sine_out = 0.923880
        8'h31: sine_out = 18'h0eed8; // sine_out = 0.932993
        8'h32: sine_out = 18'h0f109; // sine_out = 0.941544
        8'h33: sine_out = 18'h0f314; // sine_out = 0.949528
        8'h34: sine_out = 18'h0f4fa; // sine_out = 0.956940
        8'h35: sine_out = 18'h0f6ba; // sine_out = 0.963776
        8'h36: sine_out = 18'h0f853; // sine_out = 0.970031
        8'h37: sine_out = 18'h0f9c7; // sine_out = 0.975702
        8'h38: sine_out = 18'h0fb14; // sine_out = 0.980785
        8'h39: sine_out = 18'h0fc3b; // sine_out = 0.985278
        8'h3a: sine_out = 18'h0fd3a; // sine_out = 0.989177
        8'h3b: sine_out = 18'h0fe13; // sine_out = 0.992480
        8'h3c: sine_out = 18'h0fec4; // sine_out = 0.995185
        8'h3d: sine_out = 18'h0ff4e; // sine_out = 0.997290
        8'h3e: sine_out = 18'h0ffb1; // sine_out = 0.998795
        8'h3f: sine_out = 18'h0ffec; // sine_out = 0.999699
        8'h40: sine_out = 18'h10000; // sine_out = 1.000000
        8'h41: sine_out = 18'h0ffec; // sine_out = 0.999699
        8'h42: sine_out = 18'h0ffb1; // sine_out = 0.998795
        8'h43: sine_out = 18'h0ff4e; // sine_out = 0.997290
        8'h44: sine_out = 18'h0fec4; // sine_out = 0.995185
        8'h45: sine_out = 18'h0fe13; // sine_out = 0.992480
        8'h46: sine_out = 18'h0fd3a; // sine_out = 0.989177
        8'h47: sine_out = 18'h0fc3b; // sine_out = 0.985278
        8'h48: sine_out = 18'h0fb14; // sine_out = 0.980785
        8'h49: sine_out = 18'h0f9c7; // sine_out = 0.975702
        8'h4a: sine_out = 18'h0f853; // sine_out = 0.970031
        8'h4b: sine_out = 18'h0f6ba; // sine_out = 0.963776
        8'h4c: sine_out = 18'h0f4fa; // sine_out = 0.956940
        8'h4d: sine_out = 18'h0f314; // sine_out = 0.949528
        8'h4e: sine_out = 18'h0f109; // sine_out = 0.941544
        8'h4f: sine_out = 18'h0eed8; // sine_out = 0.932993
        8'h50: sine_out = 18'h0ec83; // sine_out = 0.923880
        8'h51: sine_out = 18'h0ea09; // sine_out = 0.914210
        8'h52: sine_out = 18'h0e76b; // sine_out = 0.903989
        8'h53: sine_out = 18'h0e4aa; // sine_out = 0.893224
        8'h54: sine_out = 18'h0e1c5; // sine_out = 0.881921
        8'h55: sine_out = 18'h0debe; // sine_out = 0.870087
        8'h56: sine_out = 18'h0db94; // sine_out = 0.857729
        8'h57: sine_out = 18'h0d848; // sine_out = 0.844854
        8'h58: sine_out = 18'h0d4db; // sine_out = 0.831470
        8'h59: sine_out = 18'h0d14d; // sine_out = 0.817585
        8'h5a: sine_out = 18'h0cd9f; // sine_out = 0.803208
        8'h5b: sine_out = 18'h0c9d1; // sine_out = 0.788346
        8'h5c: sine_out = 18'h0c5e4; // sine_out = 0.773010
        8'h5d: sine_out = 18'h0c1d8; // sine_out = 0.757209
        8'h5e: sine_out = 18'h0bdae; // sine_out = 0.740951
        8'h5f: sine_out = 18'h0b968; // sine_out = 0.724247
        8'h60: sine_out = 18'h0b504; // sine_out = 0.707107
        8'h61: sine_out = 18'h0b085; // sine_out = 0.689541
        8'h62: sine_out = 18'h0abeb; // sine_out = 0.671559
        8'h63: sine_out = 18'h0a736; // sine_out = 0.653173
        8'h64: sine_out = 18'h0a267; // sine_out = 0.634393
        8'h65: sine_out = 18'h09d7f; // sine_out = 0.615232
        8'h66: sine_out = 18'h0987f; // sine_out = 0.595699
        8'h67: sine_out = 18'h09368; // sine_out = 0.575808
        8'h68: sine_out = 18'h08e39; // sine_out = 0.555570
        8'h69: sine_out = 18'h088f5; // sine_out = 0.534998
        8'h6a: sine_out = 18'h0839c; // sine_out = 0.514103
        8'h6b: sine_out = 18'h07e2e; // sine_out = 0.492898
        8'h6c: sine_out = 18'h078ad; // sine_out = 0.471397
        8'h6d: sine_out = 18'h07319; // sine_out = 0.449611
        8'h6e: sine_out = 18'h06d74; // sine_out = 0.427555
        8'h6f: sine_out = 18'h067bd; // sine_out = 0.405241
        8'h70: sine_out = 18'h061f7; // sine_out = 0.382683
        8'h71: sine_out = 18'h05c22; // sine_out = 0.359895
        8'h72: sine_out = 18'h0563e; // sine_out = 0.336890
        8'h73: sine_out = 18'h0504d; // sine_out = 0.313682
        8'h74: sine_out = 18'h04a50; // sine_out = 0.290285
        8'h75: sine_out = 18'h04447; // sine_out = 0.266713
        8'h76: sine_out = 18'h03e33; // sine_out = 0.242980
        8'h77: sine_out = 18'h03817; // sine_out = 0.219101
        8'h78: sine_out = 18'h031f1; // sine_out = 0.195090
        8'h79: sine_out = 18'h02bc4; // sine_out = 0.170962
        8'h7a: sine_out = 18'h02590; // sine_out = 0.146730
        8'h7b: sine_out = 18'h01f56; // sine_out = 0.122411
        8'h7c: sine_out = 18'h01917; // sine_out = 0.098017
        8'h7d: sine_out = 18'h012d5; // sine_out = 0.073565
        8'h7e: sine_out = 18'h00c8f; // sine_out = 0.049068
        8'h7f: sine_out = 18'h00648; // sine_out = 0.024541
        8'h80: sine_out = 18'h00000; // sine_out = 0.000000
        8'h81: sine_out = 18'h3f9b8; // sine_out = -0.024541
        8'h82: sine_out = 18'h3f371; // sine_out = -0.049068
        8'h83: sine_out = 18'h3ed2b; // sine_out = -0.073565
        8'h84: sine_out = 18'h3e6e9; // sine_out = -0.098017
        8'h85: sine_out = 18'h3e0aa; // sine_out = -0.122411
        8'h86: sine_out = 18'h3fa70; // sine_out = -0.146730
        8'h87: sine_out = 18'h3f43c; // sine_out = -0.170962
        8'h88: sine_out = 18'h3ee0f; // sine_out = -0.195090
        8'h89: sine_out = 18'h3e7e9; // sine_out = -0.219101
        8'h8a: sine_out = 18'h3e1cd; // sine_out = -0.242980
        8'h8b: sine_out = 18'h3bbb9; // sine_out = -0.266713
        8'h8c: sine_out = 18'h3b5b0; // sine_out = -0.290285
        8'h8d: sine_out = 18'h3afb3; // sine_out = -0.313682
        8'h8e: sine_out = 18'h3a9c2; // sine_out = -0.336890
        8'h8f: sine_out = 18'h3a3de; // sine_out = -0.359895
        8'h90: sine_out = 18'h3be09; // sine_out = -0.382683
        8'h91: sine_out = 18'h3b843; // sine_out = -0.405241
        8'h92: sine_out = 18'h3b28c; // sine_out = -0.427555
        8'h93: sine_out = 18'h3ace7; // sine_out = -0.449611
        8'h94: sine_out = 18'h3a753; // sine_out = -0.471397
        8'h95: sine_out = 18'h3a1d2; // sine_out = -0.492898
        8'h96: sine_out = 18'h37c64; // sine_out = -0.514103
        8'h97: sine_out = 18'h3770b; // sine_out = -0.534998
        8'h98: sine_out = 18'h371c7; // sine_out = -0.555570
        8'h99: sine_out = 18'h36c98; // sine_out = -0.575808
        8'h9a: sine_out = 18'h36781; // sine_out = -0.595699
        8'h9b: sine_out = 18'h36281; // sine_out = -0.615232
        8'h9c: sine_out = 18'h37d99; // sine_out = -0.634393
        8'h9d: sine_out = 18'h378ca; // sine_out = -0.653173
        8'h9e: sine_out = 18'h37415; // sine_out = -0.671559
        8'h9f: sine_out = 18'h36f7b; // sine_out = -0.689541
        8'ha0: sine_out = 18'h36afc; // sine_out = -0.707107
        8'ha1: sine_out = 18'h36698; // sine_out = -0.724247
        8'ha2: sine_out = 18'h36252; // sine_out = -0.740951
        8'ha3: sine_out = 18'h33e28; // sine_out = -0.757209
        8'ha4: sine_out = 18'h33a1c; // sine_out = -0.773010
        8'ha5: sine_out = 18'h3362f; // sine_out = -0.788346
        8'ha6: sine_out = 18'h33261; // sine_out = -0.803208
        8'ha7: sine_out = 18'h32eb3; // sine_out = -0.817585
        8'ha8: sine_out = 18'h32b25; // sine_out = -0.831470
        8'ha9: sine_out = 18'h327b8; // sine_out = -0.844854
        8'haa: sine_out = 18'h3246c; // sine_out = -0.857729
        8'hab: sine_out = 18'h32142; // sine_out = -0.870087
        8'hac: sine_out = 18'h33e3b; // sine_out = -0.881921
        8'had: sine_out = 18'h33b56; // sine_out = -0.893224
        8'hae: sine_out = 18'h33895; // sine_out = -0.903989
        8'haf: sine_out = 18'h335f7; // sine_out = -0.914210
        8'hb0: sine_out = 18'h3337d; // sine_out = -0.923880
        8'hb1: sine_out = 18'h33128; // sine_out = -0.932993
        8'hb2: sine_out = 18'h32ef7; // sine_out = -0.941544
        8'hb3: sine_out = 18'h32cec; // sine_out = -0.949528
        8'hb4: sine_out = 18'h32b06; // sine_out = -0.956940
        8'hb5: sine_out = 18'h32946; // sine_out = -0.963776
        8'hb6: sine_out = 18'h327ad; // sine_out = -0.970031
        8'hb7: sine_out = 18'h32639; // sine_out = -0.975702
        8'hb8: sine_out = 18'h324ec; // sine_out = -0.980785
        8'hb9: sine_out = 18'h323c5; // sine_out = -0.985278
        8'hba: sine_out = 18'h322c6; // sine_out = -0.989177
        8'hbb: sine_out = 18'h321ed; // sine_out = -0.992480
        8'hbc: sine_out = 18'h3213c; // sine_out = -0.995185
        8'hbd: sine_out = 18'h320b2; // sine_out = -0.997290
        8'hbe: sine_out = 18'h3204f; // sine_out = -0.998795
        8'hbf: sine_out = 18'h32014; // sine_out = -0.999699
        8'hc0: sine_out = 18'h32000; // sine_out = -1.000000
        8'hc1: sine_out = 18'h32014; // sine_out = -0.999699
        8'hc2: sine_out = 18'h3204f; // sine_out = -0.998795
        8'hc3: sine_out = 18'h320b2; // sine_out = -0.997290
        8'hc4: sine_out = 18'h3213c; // sine_out = -0.995185
        8'hc5: sine_out = 18'h321ed; // sine_out = -0.992480
        8'hc6: sine_out = 18'h322c6; // sine_out = -0.989177
        8'hc7: sine_out = 18'h323c5; // sine_out = -0.985278
        8'hc8: sine_out = 18'h324ec; // sine_out = -0.980785
        8'hc9: sine_out = 18'h32639; // sine_out = -0.975702
        8'hca: sine_out = 18'h327ad; // sine_out = -0.970031
        8'hcb: sine_out = 18'h32946; // sine_out = -0.963776
        8'hcc: sine_out = 18'h32b06; // sine_out = -0.956940
        8'hcd: sine_out = 18'h32cec; // sine_out = -0.949528
        8'hce: sine_out = 18'h32ef7; // sine_out = -0.941544
        8'hcf: sine_out = 18'h33128; // sine_out = -0.932993
        8'hd0: sine_out = 18'h3337d; // sine_out = -0.923880
        8'hd1: sine_out = 18'h335f7; // sine_out = -0.914210
        8'hd2: sine_out = 18'h33895; // sine_out = -0.903989
        8'hd3: sine_out = 18'h33b56; // sine_out = -0.893224
        8'hd4: sine_out = 18'h33e3b; // sine_out = -0.881921
        8'hd5: sine_out = 18'h32142; // sine_out = -0.870087
        8'hd6: sine_out = 18'h3246c; // sine_out = -0.857729
        8'hd7: sine_out = 18'h327b8; // sine_out = -0.844854
        8'hd8: sine_out = 18'h32b25; // sine_out = -0.831470
        8'hd9: sine_out = 18'h32eb3; // sine_out = -0.817585
        8'hda: sine_out = 18'h33261; // sine_out = -0.803208
        8'hdb: sine_out = 18'h3362f; // sine_out = -0.788346
        8'hdc: sine_out = 18'h33a1c; // sine_out = -0.773010
        8'hdd: sine_out = 18'h33e28; // sine_out = -0.757209
        8'hde: sine_out = 18'h36252; // sine_out = -0.740951
        8'hdf: sine_out = 18'h36698; // sine_out = -0.724247
        8'he0: sine_out = 18'h36afc; // sine_out = -0.707107
        8'he1: sine_out = 18'h36f7b; // sine_out = -0.689541
        8'he2: sine_out = 18'h37415; // sine_out = -0.671559
        8'he3: sine_out = 18'h378ca; // sine_out = -0.653173
        8'he4: sine_out = 18'h37d99; // sine_out = -0.634393
        8'he5: sine_out = 18'h36281; // sine_out = -0.615232
        8'he6: sine_out = 18'h36781; // sine_out = -0.595699
        8'he7: sine_out = 18'h36c98; // sine_out = -0.575808
        8'he8: sine_out = 18'h371c7; // sine_out = -0.555570
        8'he9: sine_out = 18'h3770b; // sine_out = -0.534998
        8'hea: sine_out = 18'h37c64; // sine_out = -0.514103
        8'heb: sine_out = 18'h3a1d2; // sine_out = -0.492898
        8'hec: sine_out = 18'h3a753; // sine_out = -0.471397
        8'hed: sine_out = 18'h3ace7; // sine_out = -0.449611
        8'hee: sine_out = 18'h3b28c; // sine_out = -0.427555
        8'hef: sine_out = 18'h3b843; // sine_out = -0.405241
        8'hf0: sine_out = 18'h3be09; // sine_out = -0.382683
        8'hf1: sine_out = 18'h3a3de; // sine_out = -0.359895
        8'hf2: sine_out = 18'h3a9c2; // sine_out = -0.336890
        8'hf3: sine_out = 18'h3afb3; // sine_out = -0.313682
        8'hf4: sine_out = 18'h3b5b0; // sine_out = -0.290285
        8'hf5: sine_out = 18'h3bbb9; // sine_out = -0.266713
        8'hf6: sine_out = 18'h3e1cd; // sine_out = -0.242980
        8'hf7: sine_out = 18'h3e7e9; // sine_out = -0.219101
        8'hf8: sine_out = 18'h3ee0f; // sine_out = -0.195090
        8'hf9: sine_out = 18'h3f43c; // sine_out = -0.170962
        8'hfa: sine_out = 18'h3fa70; // sine_out = -0.146730
        8'hfb: sine_out = 18'h3e0aa; // sine_out = -0.122411
        8'hfc: sine_out = 18'h3e6e9; // sine_out = -0.098017
        8'hfd: sine_out = 18'h3ed2b; // sine_out = -0.073565
        8'hfe: sine_out = 18'h3f371; // sine_out = -0.049068
        8'hff: sine_out = 18'h3f9b8; // sine_out = -0.024541
      endcase // case (sin_addr)
   end // always @ (posedge CLK)
endmodule // sineTable18bit
